using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;

namespace EG00700
{
    public partial class Form1 : Form
    {
        bool No_data = false;
        //bool package = false;
        string RxString;
        string test = "";
        byte[] sbuffer = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ,0,0};
        //byte sindex = 0;
        StreamWriter Outfile;
        int Outfilectr = 0;

        public Form1()
        {
            InitializeComponent();
            list_comport();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }


        private void list_comport()
        {
            ToolStripMenuItem mnuCom = new ToolStripMenuItem("COM");
            this.menuStrip1.Items.Add(mnuCom);
            
            // Get a list of serial port names. 
            string[] ports = SerialPort.GetPortNames();

            //Console.WriteLine("The following serial ports were found:");

            // Display each port name to the console. 
            foreach(string port in ports)
            {                
                mnuCom.DropDownItems.Add(port, null,new EventHandler(port_Click));
            }
        }

       

        private void Form1_Load(object sender, EventArgs e)
        {
         
         serialPort1.BaudRate = 9600;
         serialPort1.DataBits = 8;
         serialPort1.Parity = (Parity)Enum.Parse(typeof(Parity), "None");
         serialPort1.StopBits = (StopBits)Enum.Parse(typeof(StopBits), "One");
         serialPort1.ReadBufferSize = 64;
        }   

        private void Form1_Close(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.Close();
            if (Outfilectr > 0)
                Outfile.Close();

        }


        
        
        private void decode_string()
        {
              
            string[] split = (System.Text.Encoding.ASCII.GetString(sbuffer)).Split(new string[] { "  " }, StringSplitOptions.None);

            CheckForIllegalCrossThreadCalls = false;
            if (split.Length>1)
            {
                if (split[1].EndsWith("?"))
                    this.label_Reference.Text = "-----";
                else if (split[1].EndsWith("!"))
                    this.label_Reference.Text = "+++++";
                else
                    this.label_Reference.Text = ((double)(Convert.ToInt16(split[1]) / 10.0)).ToString(".00");

                // channel 1

                if (split[3].EndsWith("?"))
                    this.Label_Channel1.Text = "-----";
                else if (split[3].EndsWith("!"))
                    this.Label_Channel1.Text = "+++++";
                else
                    this.Label_Channel1.Text = ((double)(Convert.ToInt16(split[3]) / 10.0)).ToString(".00");

                // channel 2

                if (split[5].EndsWith("?"))
                    this.label_Channel2.Text = "-----";
                else if (split[5].EndsWith("!"))
                    this.label_Channel2.Text = "+++++";
                else
                    this.label_Channel2.Text = ((double)(Convert.ToInt16(split[5]) / 10.0)).ToString(".00");

            }
            if (Outfilectr > 0)
            {

                if ((Outfilectr % 10) == 1)
                {
                    Outfile.Write(this.Label_Channel1.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label_Channel2.Text);
                    Outfile.Write("   ");
                    Outfile.Write(this.label_Reference.Text);
                    Outfile.Write("   ");
                    Outfile.WriteLine(Outfilectr);
                }
                Outfilectr++;
            }
        }

        
           

        

       

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (No_data == true)
            {
                this.Label_Channel1.Text = "     ";
                this.label_Channel2.Text = "     ";
                this.label_Reference.Text = "     ";
            }
            No_data = true;        // has to be reset till next tick
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Title = "Select a file";

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                Outfile = new StreamWriter(dialog.FileName);
                Outfilectr = 1;
                Outfile.WriteLine("EG00750"); 
                Outfile.WriteLine("CH1     CH2     REF");
                toolStripStatusLabel1.Text = dialog.FileName;
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.Close();
            if (Outfilectr > 0)
                Outfile.Close();

        }

        private void port_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.Close();
            
            string Port = sender.ToString();
            serialPort1.PortName = Port;
            serialPort1.Open();
            //decode_string();
        
        }

        private void serialPort1_DataReceived_1(object sender, SerialDataReceivedEventArgs e)
        {
            RxString = serialPort1.ReadExisting();

            
            test += RxString;

            int index = (test.IndexOf("\n\r")+2);
            if (index > 1 && index < 29)
            {
                test = test.Remove(0, index);
                No_data = true;
            }
            else if (index > 1 && index >= 29)
            {
                sbuffer = (System.Text.Encoding.ASCII.GetBytes(test.Substring(0, index)));
                test = test.Remove(0, index);
                decode_string();
                No_data = false;

            }
        }

        
        
       
    }
}